extern unsigned int const SCL_PIN,SDA_PIN,RESET_PIN;
extern void delay(unsigned int);
extern void scl(unsigned int);
extern void sda(unsigned int);
extern unsigned int sdain(void);
extern unsigned int sclin(void);
//extern void p_pulse(unsigned int);
extern volatile unsigned int i2c_delay;

void Start(void){
    sda(1);scl(1);
    while((sclin()&sdain())!=1);
   
    sda(0); while(sdain()!=0);delay(i2c_delay);
    scl(0); while(sclin()!=0);delay(i2c_delay);
 }

void Stop(void){
  scl(1);while(sclin()!=1);delay(i2c_delay);
  sda(1);while(sdain()!=1);delay(i2c_delay);
 }


BYTE i2c_send_byte( unsigned int data){
data|=0x100;
data&=0x1FF;
scl(0); while(sclin()!=0);
while(data<0x10000){
    sda(data>>7);while(sdain()!=(1&(data>>7)));	
	delay(i2c_delay);
    scl(1); while(sclin()!=1);delay(i2c_delay);scl(0); while(sclin()!=0);
	data<<=1;}
   
	sda(1);
    delay(i2c_delay);scl(1); while(sclin()!=1);
    delay(i2c_delay);
   	
    data=sdain();
	delay(i2c_delay);scl(0); while(sclin()!=0);
   	delay(i2c_delay);sda(0);while(sdain()!=0);
	delay(i2c_delay);
 return(data);
 }

BYTE i2c_recieve_byte(BYTE acknowledge){
unsigned int data;
data=1;
sda(1);delay(i2c_delay);
while(data<0x100){
    delay(i2c_delay);scl(1); while(sclin()!=1);delay(i2c_delay);data<<=1;data|=sdain();scl(0); while(sclin()!=0);
    
    delay(i2c_delay);}
    sda(acknowledge);while(sdain()!=acknowledge);	
	delay(i2c_delay);scl(1); while(sclin()!=1);
	delay(i2c_delay);scl(0);while(sclin()!=0);
	delay(i2c_delay);sda(0);while(sdain()!=0);
	delay(i2c_delay);
return(data);
}


unsigned int i2c_read(unsigned int cnt,BYTE SlaveAdr,BYTE *p) {      
			
			Start();
			if(i2c_send_byte(SlaveAdr)!=0){delay(i2c_delay);Stop();return(55);}
		
			while(cnt>1){
			 delay(i2c_delay);
			*p=i2c_recieve_byte(0);p++;cnt--;
     		   }
             delay(i2c_delay);*p=i2c_recieve_byte(1);
		
			 delay(i2c_delay);Stop();
			 return (0);
		     	  }
	

//------------------------------------------
unsigned int i2c_write(BYTE cnt, BYTE *p){			 
			 Start();
			 while(cnt>0){
			  if(i2c_send_byte(*p)!=0){delay(i2c_delay);Stop();return(50|(cnt<<8));} //  
			 delay(i2c_delay);p++;cnt--;
				}
				Stop();
			return(0);
}





