//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#include "hidlibrary.h"
TForm1 *Form1;
 #include <windows.h>
#include <setupapi.h>
#include <string>
 #include <string.h>
#include <fstream>
#include "includes.c"
#include "felix.cpp"
#include "Orion100.cpp"
#include "EEPROM.cpp"
#include "prim.cpp"
#include "gepard.cpp"
#include "elves.cpp"
#include "atmega128.cpp"
#include "DS1307.cpp"
#include "minika1102_3.cpp"
#include "fprint55.cpp"
#include "oka102.cpp"
#include "merc130.cpp"
#include "ST25P10.cpp"
#include "Unit2.h"
#include "Unit3.h"
unsigned int StopFlag;
AnsiString TDIRisingLog,TDIFallingLog;
//---------------------------------------------------------------------------
void DisableFreqControl(void){
Form1->ApplyFreq->Enabled=false;
Form1->DisableFreq->Enabled=false;
}
void EnableFreqControl(void){
Form1->ApplyFreq->Enabled=true;
Form1->DisableFreq->Enabled=true;
}
void CheckFreqControl(void){
if (Form1->FrequncyEnable->Checked==true) {FrequencyWarning->Show();if(Form1->Rescan->Visible==false)EnableFreqControl();}
                  else DisableFreqControl();
}

void EnableButtons(void){
 string s;
 for(int i = 0;i < Form1->ComponentCount; i++)
 {
  if(Form1->Components[i]->ClassNameIs("TButton"))
  {
   if(((TButton *)Form1->Components[i])->Tag == 1) ((TButton *)Form1->Components[i])->Enabled = true;
  }
   }
   Form1->FrequncyEnable->Checked=false;
}// ----------------

void DisableButtons(void){
 string s;
 for(int i = 0;i < Form1->ComponentCount; i++)
 {
  if(Form1->Components[i]->ClassNameIs("TButton"))
  {
   if(((TButton *)Form1->Components[i])->Tag == 1) ((TButton *)Form1->Components[i])->Enabled = false;
  }
   }
DisableFreqControl();Form1->FrequncyEnable->Checked=false;
   }// ----------------


void SetT0PR(void){
switch(Form1->MemorySelector->ItemIndex){
 case 0:{Form1->T0PR->Text="500";Form1->ShtrihMiniCB->Visible=false;}break;//orion
 case 1:{Form1->T0PR->Text="300";Form1->ShtrihMiniCB->Visible=false;}break;//fprint
 case 2:{Form1->T0PR->Text="600";
 ShowMessage("Prim requires a diode to be connected between pins 6 and 9 of connector with cathode on pin 9. \nEnumeration starts from small triangle and follows in chess order.");
               Form1->ShtrihMiniCB->Visible=false;
                 ;break;}//Prim

  case 3:{Form1->T0PR->Text="50";Form1->ShtrihMiniCB->Visible=false;}break;//Gepard
  case 4:{Form1->T0PR->Text="500";Form1->ShtrihMiniCB->Visible=true;}break;//elves
  case 5:{Form1->T0PR->Text="1500";Form1->ShtrihMiniCB->Visible=false;}break;//minika1102_3
  case 6:{Form1->T0PR->Text="500";Form1->ShtrihMiniCB->Visible=false;
     ShowMessage("WARNING !!! This Memory needs 3V power supply.");
     }break;//FPrint55
   case 7:{Form1->T0PR->Text="500";Form1->ShtrihMiniCB->Visible=false;}break;//oka
   case 8:{Form1->T0PR->Text="1";Form1->ShtrihMiniCB->Visible=false;}break;//merc130

  default:break;}
 }
void ShowX(void){AnsiString s,l;unsigned char b1;
    s="";for(b1=0;b1<32;b1++) {l="";inttohex((x[b1]),&l);s+=l+" ";}Form1->Answer->Caption=s;  Application->ProcessMessages();
}
void ActivateButt(void){
             EnableButtons();
                  Form1->Rescan->Visible=false;
                  }
void DisActivateButt(void){
           DisableButtons();
        Form1->Rescan->Visible=true;
            }
unsigned int GetFlxSize(void){if (Form1->is3CK->Checked==true)return(65536);else return (32768);}

void _PutDWord(unsigned int data,unsigned char *destination){
  *destination=data>>24;*(destination+1)=data>>16;
  *(destination+2)=data>>8;*(destination+3)=data;
}
void _PutWord(unsigned int data,BYTE *destination){
  *(destination)=data>>8;*(destination+1)=data;
}

unsigned int applyT0PR(void){
AnsiString s,s1;
unsigned int a;
s=Form1->T0PR->Text;for(a=1;a<8;a++){if(s[a]==32) continue;s1+=s[a];}Form1->T0PR->Text=s1;
a=StrToInt(s1);//ShowMessage("A="+IntToStr(a));
   y[1]=cmd_set_T0PR;
   y[2]=a>>24;y[3]=a>>16;y[4]=a>>8;y[5]=a;
   return HostToDevice();
}

   //---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{          // shift_mask & shift are need for correct (PA | BA) combinations for each chip
           //they depend of bitsize of a page
    pages=1024;page_sz=264;shift_mask=128;shift=2;//AT45DB021
    pages=4096;page_sz=528;shift_mask=64;shift=4;//AT45DB161


   HIDLibrary  <bool> a;
    HIDLibrary <string> z;

     HIDLibrary <int> d;
     unsigned long zw;
   unsigned int b,b1,flag;

  bool devstat;
   Rescan->Visible=false;
  begin: if (!a.IsAvailable())  {ShowMessage("Unable to load hid.dll or locate functions entry points");}

    StopFlag=0;

 a.EnumerateHIDDevices();
         if ( a.Connect() ) {devstat=true;DeviceStation->Caption="Device Detected";} else  {devstat=false;DeviceStation->Caption="Device NOT Detected";}

if (devstat) {h = CreateFile(m_ConnectedDevice.c_str(),GENERIC_READ|GENERIC_WRITE,
                   FILE_SHARE_READ |FILE_SHARE_WRITE,
                 0,OPEN_EXISTING,0,0);//  FILE_FLAG_OVERLAPPED
                  ActivateButt();
                  } else DisActivateButt();
  if (h==0) {Rescan->Visible=true;}
 MemorySelector->ItemIndex=9;SetT0PR();
 LogEnable->Checked=false;
 EepromDev->ItemIndex=0;
 ShtrihMiniCB->Visible=false;
 TDIRisingLog="";TDIFallingLog="";
 FrequncyEnable->Checked=false; CheckFreqControl();
 }
//---------------------------------------------------
void __fastcall TForm1::RescanClick(TObject *Sender)
{
   bool devstat;
  if (!a.IsAvailable())  {ShowMessage("Unable to load hid.dll or locate functions entry points");}



 a.EnumerateHIDDevices();
         if ( a.Connect() ) {devstat=true;DeviceStation->Caption="Device Detected";} else  {devstat=false;DeviceStation->Caption="Device NOT Detected";}

if (devstat) {h = CreateFile(m_ConnectedDevice.c_str(),GENERIC_READ|GENERIC_WRITE,
                   FILE_SHARE_READ |FILE_SHARE_WRITE,
                 0,OPEN_EXISTING,0,0);//GENERIC_READ||GENERIC_WRITE  FILE_FLAG_OVERLAPPED
                  ActivateButt();
                  } else DisableButtons();


}


void __fastcall TForm1::read_fpClick(TObject *Sender)
{
AnsiString s;
char *r;
ofstream file;
                 applyT0PR();

               StopFlag=0;
             TForm1::SaveDlg->Execute();
              s=TForm1::SaveDlg->FileName;
              r = s.c_str();

         file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");goto end_read_fp;}

        switch (MemorySelector->ItemIndex){

 case 0:{
         if (read_Orion100(&file)!=0) {DisActivateButt();CloseHandle(h);}
         }  //case0
       break;
        //-----------
  case 1:{ //ShowMessage("Fprint");
      if (read_felix(&file,GetFlxSize())!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
        //-------
   case 2:{ //
      if (  read_prim(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case2
      break;
        //-------

   case 3:{ //
      if (  read_gepard(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case3
         break;
     //-------
   case 4:{ //
      if (  read_elves(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case3
         break;
     //-------
   case 5:{ //
      if (  read_minika1102_3(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }
         break;
     //-------
   case 6:{ //
      if (  read_fprint55(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }
         break;
     //------
      default:
      break;
             }//switch

    ProgressBar->Position=(0);
 file.close();

  end_read_fp:




}
//---------------------------------------------------------------------------

void __fastcall TForm1::erase_fpClick(TObject *Sender)
{          applyT0PR();
            StopFlag=0;
  if(MessageBox(NULL,"Warning, You may kill IT now!!! Continue ?","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES)

 if( MessageBox(NULL,"This is Your LAST Chance to SAY NO.","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES)

        switch (MemorySelector->ItemIndex){

 case 0:{
         if (erase_Orion100()!=0) {DisActivateButt();CloseHandle(h);}
         }  //case0
       break;
        //-----------
  case 1:{
      if (erase_felix(GetFlxSize())!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
        //-------
   case 2:{ 
      if (  erase_prim()==0){if(EraseOnlyFlag->Checked==false) init_prim();}else {DisActivateButt();CloseHandle(h);}

      }// case1
      break;
        //-----------
  case 3:{
      if (erase_gepard()!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
  case 4:{
      if (erase_elves()!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;

        //-------
   case 5:{ //
      if (  erase_minika1102_3()!=0) {DisActivateButt();CloseHandle(h);}
      }
         break;
     //-------

    case 6:{ //
     ShowMessage("This memory can NOT be erased over I2C, only as nake 25P10 over SPI.");
      }
         break;
     //-------

      case 7:{ //
      if (  init_oka102()!=0) {DisActivateButt();CloseHandle(h);}
      }
         break;
     //-------
      default:
      break;
             }//switch
       


    } 
//---------------------------------------------------------------------------

void __fastcall TForm1::write_fpClick(TObject *Sender)
{
char *r;
ifstream file;
AnsiString s;
                   applyT0PR();
                    StopFlag=0;
  if(MessageBox(NULL,"Warning, You may kill IT now!!! Continue ?","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES)

 if( MessageBox(NULL,"This is Your LAST Chance to SAY NO.","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES){

            TForm1::OpenDlg->Execute();
               s=TForm1::OpenDlg->FileName;
               r = s.c_str();

               file.open(r, ios_base::binary);
      if ( !file.is_open())  ShowMessage("Unable to open file");
         else
         switch (MemorySelector->ItemIndex){

 case 0:{
         if (write_Orion100(&file)!=0) {DisActivateButt();CloseHandle(h);}
         }  //case0
       break;
        //-----------
  case 1:{ //ShowMessage("Fprint");
      if (write_felix(&file,GetFlxSize())!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
         //-----------
  case 2:{ //
      if (write_prim(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
         //-----------
  case 3:{ //
      if (write_gepard(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
  case 4:{ //
      if (write_elves(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
         //-----------
   case 5:{ //
      if (write_minika1102_3(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
         //-----------
   case 6:{ //
      if (write_fprint55(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
         //-----------

      default:
      break;
             }//switch      write_fprint55(
 file.close();}

  ProgressBar->Position=(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::show_passClick(TObject *Sender)
{AnsiString pass;
                      applyT0PR();
        switch (MemorySelector->ItemIndex){

 case 0:{
         if (get_Orion100_pass(&pass)!=0) {DisActivateButt();CloseHandle(h);}
         }  //case0
       break;
        //-----------
  case 1:{ //ShowMessage("Fprint");
      if (get_felix_pass(&pass)!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
        //-------
   case 2:{ //
    if ( get_prim_pass(&pass)!=0) {DisActivateButt();CloseHandle(h);}
      }// case2
      break;
        //-------

   case 3:{ //
      if (  get_gepard_pass(&pass)!=0) {DisActivateButt();CloseHandle(h);}
      }// case3
         break;
     //-------
   case 4:{ //
      if (  get_elves_pass(&pass)!=0) {DisActivateButt();CloseHandle(h);}
      }// case3
         break;
     //-------
    case 6:{ //
      if (  get_fprint55_pass(&pass)!=0) {DisActivateButt();CloseHandle(h);}
      }// case3
         break;
     //-------
    case 7:{ //
      if (  get_oka102_pass(&pass)!=0) {DisActivateButt();CloseHandle(h);}
      }// pay cts2000
         break;
     //-------
       case 8:{ //
      if (  get_merc130_pass(&pass)!=0) {DisActivateButt();CloseHandle(h);}
      }//
         break;
     //-------
      default:
      break;
             }//switch
         password->Text=pass;

}



void __fastcall TForm1::VerifyClick(TObject *Sender)
{ char *r;
ifstream file;
AnsiString s;   StopFlag=0;
                 applyT0PR();
            TForm1::OpenDlg->Execute();
               s=TForm1::OpenDlg->FileName;
               r = s.c_str();

               file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");goto end_fp_verify;}

        switch (MemorySelector->ItemIndex){

 case 0:{
         if (verify_Orion100(&file)!=0) {DisActivateButt();CloseHandle(h);}
         }  //case0
       break;
        //-----------
  case 1:{ //ShowMessage("Fprint");
      if (verify_felix(&file,GetFlxSize())!=0) {DisActivateButt();CloseHandle(h);}
      }// case1
      break;
        //-------
   case 2:{ //
    //  if (  read_prim(&file)!=0) {DisActivateButt();CloseHandle(h);}
     ShowMessage("I'm sorry, not realized yet");

      }// case2
      break;
        //-------

   case 3:{ //
     if (  verify_gepard(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case3
         break;
     //-------
   case 4:{ //
      if (  verify_elves(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case3
         break;
     //-------




  case 6:{ //
      if ( verify_fprint55(&file)!=0) {DisActivateButt();CloseHandle(h);}
      }// case3
         break;
     //-------


      default:
      break;
             }//switch

file.close();
end_fp_verify:
      }
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::StopClick(TObject *Sender)
{
if(StopFlag==0)StopFlag=100;
}
//---------------------------------------------------------------------------
 void __fastcall TForm1::MemorySelectorChange(TObject *Sender)
{SetT0PR();
 FocusControl(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ReadEEPROMClick(TObject *Sender)
{AnsiString s;unsigned int size;
char *r;
ofstream file;   applyT0PR();
               StopFlag=0;
              TForm1::SaveDlg->Execute();
              s=TForm1::SaveDlg->FileName;
              r = s.c_str();

          file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");goto end_read_eeprom;}
   switch(EepromDev->ItemIndex){
   case 0 :size=32768;break;
   case 1 :size=65536;break;
   case 2 :size=65536*2;break;
   default :break;}
    if (   read_EEPROM(&file,size,0xA0|((EepromSlaveAdr->ItemIndex)<<1))   !=0) {DisActivateButt();CloseHandle(h);}
end_read_eeprom:
      }
//---------------------------------------------------------------------------

void __fastcall TForm1::WriteEEPROMClick(TObject *Sender)
{
char *r;
ifstream file;unsigned int size;
AnsiString s;       applyT0PR();
                    StopFlag=0;
  if(MessageBox(NULL,"Warning, You may kill IT now!!! Continue ?","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES)

 if( MessageBox(NULL,"This is Your LAST Chance to SAY NO.","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES){
            TForm1::OpenDlg->Execute();
               s=TForm1::OpenDlg->FileName;
               r = s.c_str();

               file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");} else {
   switch(EepromDev->ItemIndex){
   case 0 :size=32768;break;
   case 1 :size=65536;break;
   case 2 :size=65536*2;break;
   default :break;}

    if (   write_EEPROM(&file,size,0xA0|((EepromSlaveAdr->ItemIndex)<<1))  !=0) {DisActivateButt();CloseHandle(h);}
}}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::verify_eepromClick(TObject *Sender)
{ char *r;
ifstream file;unsigned int size;
AnsiString s;   StopFlag=0;
                  applyT0PR();
            TForm1::OpenDlg->Execute();
               s=TForm1::OpenDlg->FileName;
               r = s.c_str();
          
               file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");goto end_eeprom_verify;}
   switch(EepromDev->ItemIndex){
   case 0 :size=32768;break;
   case 1 :size=65536;break;
   case 2 :size=65536*2;break;
   default :break;}


     if (eeprom_verify(&file,size,0xA0|((EepromSlaveAdr->ItemIndex)<<1)) !=0) {DisActivateButt();CloseHandle(h);}
end_eeprom_verify:}
//---------------------------------------------------------------------------



void __fastcall TForm1::ApplyT0PRClick(TObject *Sender)
{
  applyT0PR();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::erase_eepromClick(TObject *Sender)
{unsigned int size;
 applyT0PR();
                    StopFlag=0;
  if(MessageBox(NULL,"Warning, You may kill IT now!!! Continue ?","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES)

 if( MessageBox(NULL,"This is Your LAST Chance to SAY NO.","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES){
   switch(EepromDev->ItemIndex){
   case 0 :size=32768;break;
   case 1 :size=65536;break;
   case 2 :size=65536*2;break;
   default :break;}

       if( eeprom_erase(size,0xA0|((EepromSlaveAdr->ItemIndex)<<1)) !=0) {DisActivateButt();CloseHandle(h);}
}}
//---------------------------------------------------------------------------


void __fastcall TForm1::is_eeprom_blankClick(TObject *Sender)
{unsigned int size;
   applyT0PR();
   switch(EepromDev->ItemIndex){
   case 0 :size=32768;break;
   case 1 :size=65536;break;
   case 2 :size=65536*2;break;
   default :break;}


   if (   eeprom_blank_check(size,0xA0|((EepromSlaveAdr->ItemIndex)<<1)) ) {DisActivateButt();CloseHandle(h);}
}
//---------------------------------------------------------------------------




void __fastcall TForm1::AtmegaReadClick(TObject *Sender)
{
 Form1->Answer->Caption="";
AnsiString s;
char *r;
ofstream file;
                 applyT0PR();

               StopFlag=0;
              TForm1::SaveDlg->Execute();
              s=TForm1::SaveDlg->FileName;
              r = s.c_str();

          file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");goto end_read_mega;}

 if ( read_atmega(&file) !=0) {DisActivateButt();CloseHandle(h);}

 end_read_mega:}
//---------------------------------------------------------------------------

void __fastcall TForm1::AtmegaEraseClick(TObject *Sender)
{
  Form1->Answer->Caption="";
                    applyT0PR();
   if(MessageBox(NULL,"Warning, You may kill IT now!!! Continue ?","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES)

 if( MessageBox(NULL,"This is Your LAST Chance to SAY NO.","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES)
 if ( erase_atmega() !=0) {DisActivateButt();CloseHandle(h);}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AtmegaWriteClick(TObject *Sender)
{   char *r;
ifstream file;
AnsiString s;
     if(MessageBox(NULL,"Warning, You may kill IT now!!! Continue ?","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES)

 if( MessageBox(NULL,"This is Your LAST Chance to SAY NO.","Optional warning",MB_YESNO|MB_ICONWARNING
    )==IDYES){


   Form1->Answer->Caption="";


  StopFlag=0;
                 applyT0PR();
           OpenDlg->Filter="binaries|*.bin|tsk|*.tsk|hex|*.hex";
            TForm1::OpenDlg->Execute();

               s=TForm1::OpenDlg->FileName;
               r = s.c_str();
              if(Form1->OpenDlg->FilterIndex!=3) file.open(r, ios_base::binary);
                                            else file.open(r, ios_base::in);
           OpenDlg->Filter="binaries|*.bin|tsk|*.tsk";
      if ( !file.is_open()) { ShowMessage("Unable to open file");}else
    {  //if(OpenDlg->FilterIndex==3) ShowMessage("HEX");
 if ( write_atmega(&file) !=0) {DisActivateButt();CloseHandle(h);}
  }//else
 } }
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
CloseHandle(h);
StopFlag=100;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TaskSelectorClick(TObject *Sender)
{
   if (TaskSelector->PageIndex==0) T0PR->Text="1";
   if (TaskSelector->PageIndex==1) T0PR->Text="500";//eeproms
   if (TaskSelector->PageIndex==2) {T0PR->Text="1";AtmegaShowFuses(0xFF,0xC9,0xFF);}//Mega     SHTRIH M FR K
   if (TaskSelector->PageIndex==4) T0PR->Text="1";//25p10
   }
//---------------------------------------------------------------------------

void __fastcall TForm1::Mega128StopClick(TObject *Sender)
{
if(StopFlag==0)StopFlag=100;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AtmegaVerifyClick(TObject *Sender)
{
{
   Form1->Answer->Caption="";


   char *r;
ifstream file;
AnsiString s;   StopFlag=0;
                 applyT0PR();

           OpenDlg->Filter="binaries|*.bin|tsk|*.tsk|hex|*.hex";
            TForm1::OpenDlg->Execute();

               s=TForm1::OpenDlg->FileName;
               r = s.c_str();
              if(Form1->OpenDlg->FilterIndex!=3) file.open(r, ios_base::binary);
                                            else file.open(r, ios_base::in);
           OpenDlg->Filter="binaries|*.bin|tsk|*.tsk";
      if ( !file.is_open()) { ShowMessage("Unable to open file");goto end_write_mega;}

 if ( verify_atmega(&file) !=0) {DisActivateButt();CloseHandle(h);}

end_write_mega: }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DS1307ReadDateTimeClick(TObject *Sender)
{          applyT0PR();
 if ( DS1307GetDate() !=0) {DisActivateButt();CloseHandle(h);}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::DS1307WriteDateTimeClick(TObject *Sender)
{
          applyT0PR();
 if ( DS1307SetDate() !=0) {DisActivateButt();CloseHandle(h);}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DS1307ReadMemClick(TObject *Sender)
{
AnsiString s;
char *r;
ofstream file;    StopFlag=0;
                 applyT0PR();

               StopFlag=0;
              TForm1::SaveDlg->Execute();
              s=TForm1::SaveDlg->FileName;
              r = s.c_str();

          file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");goto end_read_DS;}

 if ( read_DS1307(&file) !=0) {DisActivateButt();CloseHandle(h);}
end_read_DS:}
//---------------------------------------------------------------------------

void __fastcall TForm1::DS1307WriteMemClick(TObject *Sender)
{
AnsiString s;
char *r;
ifstream file;    StopFlag=0;
                 applyT0PR();

               StopFlag=0;
              TForm1::OpenDlg->Execute();
              s=TForm1::OpenDlg->FileName;
              r = s.c_str();

          file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");goto end_write_DS;}

 if ( write_DS1307(&file) !=0) {DisActivateButt();CloseHandle(h);}
end_write_DS:

}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckPinsClick(TObject *Sender)
{ const BYTE 	
  pin_test_Zero_ok=1,
  pin_test_One_ok=2
  ;
  AnsiString result="";
  ShowMessage("Unplug any device or chip connected to gadjet and remain R pull ups on SDA und SCL.");
  y[1]=cmd_check_pins;
  if(HostToDevice()==0){
  if(!(x[2]&pin_test_Zero_ok)) result+="Select: Can't set '0'. Pin on Vp ! \n";
  if(!(x[2]&pin_test_One_ok))  result+="Select: Can't set '1'. Pin on GND ! \n";
  if(!(x[3]&pin_test_Zero_ok)) result+="SCL: Can't set '0'. Pin on Vp ! \n";
  if(!(x[3]&pin_test_One_ok))  result+="SCL: Can't set '1.' Pin on GND !\n";
  if(!(x[4]&pin_test_Zero_ok)) result+="SDA: Can't set '0'. Pin on Vp ! \n";
  if(!(x[4]&pin_test_One_ok))  result+="SDA: Can't set '1'. Pin on GND !\n";
  if((x[5]&10)==8) result+="Short circuit between Sel and SDA \n";
  if((x[5]&5)==4)  result+="Short circuit between Sel and SCL \n";
  if((x[6]&12)==8) result+="Short circuit between SDA and SCL \n";
  if(result!="") ShowMessage(result);else ShowMessage("It's allright.");
  } else {DisActivateButt();CloseHandle(h);}
  }
//---------------------------------------------------------------------------

void __fastcall TForm1::LogEnableClick(TObject *Sender)
{if(LogEnable->Checked==true) LogForm->Show();else LogForm->Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Flashes25ReadClick(TObject *Sender)
{      AnsiString s,l;
unsigned char b1;

         applyT0PR();

char *r;
ofstream file;    StopFlag=0;
                 applyT0PR();

               StopFlag=0;
              TForm1::SaveDlg->Execute();
              s=TForm1::SaveDlg->FileName;
              r = s.c_str();

          file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");} else read_25P10(&file);
       }
//---------------------------------------------------------------------------

void __fastcall TForm1::Flashes25EraseClick(TObject *Sender)
{      AnsiString s,l;
unsigned char b1;
             y[1]=cmd_set_SPI_ioconfig;
      HostToDevice(); //if(!=0) return (DeviceLost);
             //ShowMessage("Fprint55");

       y[1]=cmd_SPI8BitsSendRecieve;
       y[2]=1;
       y[3]=6;
       HostToDevice();

       y[1]=cmd_SPI8BitsSendRecieve;
       y[2]=1;
       y[3]=0xC7;

       HostToDevice();
    //s="";for(b1=0;b1<32;b1++) {l="";inttohex((x[b1]),&l);s+=l+" ";}Form1->Answer->Caption=s;  Application->ProcessMessages();
       ShowX();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::CS_ONEClick(TObject *Sender)
{
        y[1]=cmd_SetCS_ONE;
       HostToDevice();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CS_ZEROClick(TObject *Sender)
{
       y[1]=cmd_SetCS_ZERO;
       HostToDevice();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SCK_ONEClick(TObject *Sender)
{
       y[1]=cmd_SetSCK_ONE;
       HostToDevice();
      if (SCK_StatLabel->Caption=="0")  TDIRisingLog+=TDI_StatLabel->Caption;
       TDILogRisingEdge->Text=TDIRisingLog;
       }
//---------------------------------------------------------------------------

void __fastcall TForm1::SCK_ZEROClick(TObject *Sender)
{
       y[1]=cmd_SetSCK_ZERO;
       HostToDevice();
       if (SCK_StatLabel->Caption=="1")  TDIFallingLog+=TDI_StatLabel->Caption;
       TDILogFallingEdge->Text=TDIFallingLog;
       }
//---------------------------------------------------------------------------

void __fastcall TForm1::TDO_ONEClick(TObject *Sender)
{
       y[1]=cmd_SetTDO_ONE;
       HostToDevice();
    
       }
//---------------------------------------------------------------------------

void __fastcall TForm1::TDO_ZEROClick(TObject *Sender)
{
       y[1]=cmd_SetTDO_ZERO;
       HostToDevice();
}
//---------------------------------------------------------------------------

unsigned char GetSPIStat(void){

       y[1]=cmd_GetSPI_Stat;
       unsigned char temp=HostToDevice();
       Form1->SCK_StatLabel->Caption=IntToStr(x[2]);
       Form1->CS_StatLabel->Caption=IntToStr(x[3]);
       Form1->TDO_StatLabel->Caption=IntToStr(x[4]);
       Form1->TDI_StatLabel->Caption=IntToStr(x[5]);
return(temp);}
void __fastcall TForm1::Poll_SPIClick(TObject *Sender)
{ StopFlag=0;
while(StopFlag==0 && GetSPIStat()==0){
       Application->ProcessMessages();
}//while
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StopPollClick(TObject *Sender)
{
StopFlag=5;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetSPI_IOCFGClick(TObject *Sender)
{
       y[1]=cmd_set_SPI_ioconfig;
       HostToDevice();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SendByte1SPIClick(TObject *Sender)
{   AnsiString s;
        applyT0PR();

        s=Byte1ToSend->Text;
       y[1]=cmd_SendByteSPI_No_CS_Control;
       y[2]=StrToInt(s);
       HostToDevice();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::SendByte2SPIClick(TObject *Sender)
{    AnsiString s;
        applyT0PR();

        s=Byte2ToSend->Text;
       y[1]=cmd_SendByteSPI_No_CS_Control;
       y[2]=StrToInt(s);
       HostToDevice();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::SendByte3SPIClick(TObject *Sender)
{   AnsiString s;
        applyT0PR();

        s=Byte3ToSend->Text;
       y[1]=cmd_SendByteSPI_No_CS_Control;
       y[2]=StrToInt(s);
       HostToDevice();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::SCK_Pulse_010Click(TObject *Sender)
{
       y[1]=cmd_SetSCK_ONE;
       HostToDevice();

       GetSPIStat();
       TDIRisingLog+=TDI_StatLabel->Caption;
       TDILogRisingEdge->Text=TDIRisingLog;

       y[1]=cmd_SetSCK_ZERO;
       HostToDevice();

       GetSPIStat();
       TDIFallingLog+=TDI_StatLabel->Caption;
       TDILogFallingEdge->Text=TDIFallingLog;

       }
//---------------------------------------------------------------------------

void __fastcall TForm1::SCK_Pulse_101Click(TObject *Sender)
{
     y[1]=cmd_SetSCK_ZERO;
     HostToDevice();

       GetSPIStat();
       TDIFallingLog+=TDI_StatLabel->Caption;
       TDILogFallingEdge->Text=TDIFallingLog;


       y[1]=cmd_SetSCK_ONE;
       HostToDevice();

       GetSPIStat();
       TDIRisingLog+=TDI_StatLabel->Caption;
       TDILogRisingEdge->Text=TDIRisingLog;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClrRisingClick(TObject *Sender)
{  TDIRisingLog="";
   TDILogRisingEdge->Text=TDIRisingLog;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClrFallingClick(TObject *Sender)
{  TDIFallingLog="";
   TDILogFallingEdge->Text=TDIFallingLog;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::SPI_Stop_BtnClick(TObject *Sender)
{
StopFlag=5;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Flashes25WriteClick(TObject *Sender)
{     AnsiString s,l;
//unsigned char b1;

         applyT0PR();

char *r;
ifstream file;
               StopFlag=0;
              TForm1::OpenDlg->Execute();
              s=TForm1::OpenDlg->FileName;
              r = s.c_str();

          file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");} else write_25P10(&file);

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Flashes25VerifyClick(TObject *Sender)
{
     AnsiString s,l;
         applyT0PR();

char *r;
ifstream file;
               StopFlag=0;
              TForm1::OpenDlg->Execute();
              s=TForm1::OpenDlg->FileName;
              r = s.c_str();

          file.open(r, ios_base::binary);
      if ( !file.is_open()) { ShowMessage("Unable to open file");} else verify_25P10(&file);

}
void __fastcall TForm1::CollectFuses(TObject *Sender)
{  unsigned char a,b,c;
AtmegaCollectFuses(&a,&b,&c);
}
void __fastcall TForm1::ReadFusesClick(TObject *Sender)
{   applyT0PR();
AtmgaReadFuses();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FrequncyEnableClick(TObject *Sender)
{
 CheckFreqControl();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ApplyFreqClick(TObject *Sender)
{  unsigned int divider;
divider=30000;

  switch (Form1->FreqSelector->ItemIndex){
      case 0: divider=300000;break;
      case 1: divider=30000;break;
      case 2: divider=3000;break;
      case 3: divider=300;break;
      case 4: divider=30;break;
      case 5: divider=3;break;
      break;
        }



       y[1]=cmd_Freq_at_P0_21_ON;
       y[2]=divider>>24;
       y[3]=divider>>16;
       y[4]=divider>>8;
       y[5]=divider;


       HostToDevice();
       ShowX();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::DisableFreqClick(TObject *Sender)
{
      y[1]=cmd_Freq_at_P0_21_OFF;
       HostToDevice();
      ShowX();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GetATmegaIDClick(TObject *Sender)
{AnsiString s,l;
if (applyT0PR()==0){GetMegaID();
 inttohex(x[2],&s);inttohex(x[3],&s);inttohex(x[4],&s);inttohex(x[5],&s);
lblATmegaID->Caption="Atmega128 ID is 1E 97 02 FF. Recieved ID is "+s;}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::WriteFusesClick(TObject *Sender)
{   applyT0PR();
ATmegaWriteFuses();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Get_25P10_IDClick(TObject *Sender)
{
GetID_25P10();        
}
//---------------------------------------------------------------------------

