//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <TabNotBk.hpp>
#include <Mask.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TLabel *DeviceStation;
        TOpenDialog *OpenDlg;
        TSaveDialog *SaveDlg;
        TProgressBar *ProgressBar;
        TButton *Rescan;
        TLabel *Answer;
        TCheckBox *is3CK;
        TTabbedNotebook *TaskSelector;
        TButton *ShowPass;
        TButton *Read;
        TButton *Verify;
        TEdit *password;
        TButton *Stop;
        TButton *Write;
        TButton *Init;
        TComboBox *MemorySelector;
        TButton *ReadEEPROM;
        TButton *WriteEEPROM;
        TButton *verify_eeprom;
        TButton *erase_eeprom;
        TButton *is_eeprom_blank;
        TMaskEdit *T0PR;
        TStaticText *StaticText1;
        TButton *ApplyT0PR;
        TComboBox *EepromDev;
        TComboBox *EepromSlaveAdr;
        TLabel *Label1;
        TCheckBox *EraseOnlyFlag;
        TLabel *Label2;
        TButton *AtmegaRead;
        TButton *AtmegaErase;
        TButton *AtmegaWrite;
        TButton *Mega128Stop;
        TButton *AtmegaVerify;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TButton *DS1307ReadDateTime;
        TButton *DS1307WriteDateTime;
        TMaskEdit *DS1307Date;
        TMaskEdit *DS1307Time;
        TLabel *Label7;
        TLabel *Label8;
        TButton *DS1307ReadMem;
        TButton *DS1307WriteMem;
        TLabel *Label9;
        TLabel *Label10;
        TCheckBox *ShtrihMiniCB;
        TLabel *HexFileAnlze;
        TButton *CheckPins;
        TCheckBox *LogEnable;
        TButton *Flashes25Read;
        TButton *Flashes25Erase;
        TButton *CS_ONE;
        TButton *CS_ZERO;
        TButton *SCK_ONE;
        TButton *SCK_ZERO;
        TButton *TDO_ONE;
        TButton *TDO_ZERO;
        TButton *Poll_SPI;
        TButton *StopPoll;
        TLabel *CS_StatLabel;
        TLabel *SCK_StatLabel;
        TLabel *TDO_StatLabel;
        TLabel *Label11;
        TLabel *TDI_StatLabel;
        TButton *SetSPI_IOCFG;
        TEdit *Byte1ToSend;
        TButton *SendByte1SPI;
        TEdit *Byte2ToSend;
        TButton *SendByte2SPI;
        TEdit *Byte3ToSend;
        TButton *SendByte3SPI;
        TEdit *TDILogRisingEdge;
        TEdit *TDILogFallingEdge;
        TButton *SCK_Pulse_010;
        TButton *SCK_Pulse_101;
        TButton *ClrRising;
        TButton *ClrFalling;
        TButton *SPI_Stop_Btn;
        TButton *Flashes25Write;
        TLabel *Label12;
        TButton *Flashes25Verify;
        TCheckBox *cbCKOPT;
        TCheckBox *cbM103C;
        TCheckBox *cbJTAGEN;
        TCheckBox *cbWDTON;
        TCheckBox *cbEESAVE;
        TCheckBox *cbOCDEN;
        TCheckBox *cbBOOTSZ1;
        TCheckBox *cbBOOTRST;
        TCheckBox *cbBODLEVEL;
        TCheckBox *cbBODEN;
        TCheckBox *cbSUT1;
        TCheckBox *cbSUT0;
        TCheckBox *cbCKSEL0;
        TCheckBox *cbCKSEL1;
        TCheckBox *cbCKSEL2;
        TCheckBox *cbCKSEL3;
        TCheckBox *cbBOOTSZ0;
        TButton *ReadFuses;
        TButton *WriteFuses;
        TLabel *lblExtendedFuses;
        TLabel *lblHighFuses;
        TLabel *lblLowFuses;
        TCheckBox *FrequncyEnable;
        TButton *ApplyFreq;
        TButton *DisableFreq;
        TComboBox *FreqSelector;
        TButton *GetATmegaID;
        TLabel *lblATmegaID;
        TLabel *Label13;
        TButton *Get_25P10_ID;

        //void __fastcall ReadClick(TObject *Sender);
        void __fastcall RescanClick(TObject *Sender);
        void __fastcall read_fpClick(TObject *Sender);
        void __fastcall erase_fpClick(TObject *Sender);
        void __fastcall write_fpClick(TObject *Sender);
        void __fastcall show_passClick(TObject *Sender);
        void __fastcall VerifyClick(TObject *Sender);
       
        void __fastcall StopClick(TObject *Sender);
        void __fastcall MemorySelectorChange(TObject *Sender);
        void __fastcall ReadEEPROMClick(TObject *Sender);
        void __fastcall WriteEEPROMClick(TObject *Sender);
        void __fastcall verify_eepromClick(TObject *Sender);
        void __fastcall ApplyT0PRClick(TObject *Sender);
        void __fastcall erase_eepromClick(TObject *Sender);
        void __fastcall is_eeprom_blankClick(TObject *Sender);
        void __fastcall AtmegaReadClick(TObject *Sender);
        void __fastcall AtmegaEraseClick(TObject *Sender);
        void __fastcall AtmegaWriteClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall TaskSelectorClick(TObject *Sender);
        void __fastcall Mega128StopClick(TObject *Sender);
        void __fastcall AtmegaVerifyClick(TObject *Sender);
        void __fastcall DS1307ReadDateTimeClick(TObject *Sender);
        void __fastcall DS1307WriteDateTimeClick(TObject *Sender);
        void __fastcall DS1307ReadMemClick(TObject *Sender);
        void __fastcall DS1307WriteMemClick(TObject *Sender);
        void __fastcall CheckPinsClick(TObject *Sender);
        void __fastcall LogEnableClick(TObject *Sender);
       // void __fastcall ClearLogClick(TObject *Sender);
        void __fastcall Flashes25ReadClick(TObject *Sender);
        void __fastcall Flashes25EraseClick(TObject *Sender);
        void __fastcall CS_ONEClick(TObject *Sender);
        void __fastcall CS_ZEROClick(TObject *Sender);
        void __fastcall SCK_ONEClick(TObject *Sender);
        void __fastcall SCK_ZEROClick(TObject *Sender);
        void __fastcall TDO_ONEClick(TObject *Sender);
        void __fastcall TDO_ZEROClick(TObject *Sender);
        void __fastcall Poll_SPIClick(TObject *Sender);
        void __fastcall StopPollClick(TObject *Sender);
        void __fastcall SetSPI_IOCFGClick(TObject *Sender);
        void __fastcall SendByte1SPIClick(TObject *Sender);
        void __fastcall SendByte2SPIClick(TObject *Sender);
        void __fastcall SendByte3SPIClick(TObject *Sender);
        void __fastcall SCK_Pulse_010Click(TObject *Sender);
        void __fastcall SCK_Pulse_101Click(TObject *Sender);
        void __fastcall ClrRisingClick(TObject *Sender);
        void __fastcall ClrFallingClick(TObject *Sender);
        void __fastcall SPI_Stop_BtnClick(TObject *Sender);
        void __fastcall Flashes25WriteClick(TObject *Sender);
        void __fastcall Flashes25VerifyClick(TObject *Sender);
        void __fastcall CollectFuses(TObject *Sender);
        void __fastcall ReadFusesClick(TObject *Sender);
        void __fastcall FrequncyEnableClick(TObject *Sender);
        void __fastcall ApplyFreqClick(TObject *Sender);
        void __fastcall DisableFreqClick(TObject *Sender);
        void __fastcall GetATmegaIDClick(TObject *Sender);
        void __fastcall WriteFusesClick(TObject *Sender);
        void __fastcall Get_25P10_IDClick(TObject *Sender);
       // void __fastcall TaskSelectorChange(TObject *Sender, int NewTab,
       //   bool &AllowChange);
        //void __fastcall fp_selectorChange(TObject *Sender);
        //void __fastcall freq_applyClick(TObject *Sender);
        //void __fastcall freq_switchClick(TObject *Sender);
        //void __fastcall prim_iniClick(TObject *Sender);

     
private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
