extern unsigned char usb_out[];
extern void PDO(unsigned int );
extern void SCK(unsigned int );
extern unsigned int PDI(void);
extern void delay(unsigned int);
extern void n_pulse(unsigned int,unsigned int);
const BYTE PRG_ENA=0xAC,
           READ_MEM=0x20,
		   CHIP_ERASE=0xAC,
           WRITE_PGM_PAGE=0x4C,
           LOAD_PGM_PAGE=0x40,
		   WRITE_FUSE_LOW_msb=0xAC,  		    
		   WRITE_FUSE_LOW_lsb=0xA0,	  
		   WRITE_FUSE_HIGH_msb=0xAC,	 
		   WRITE_FUSE_HIGH_lsb=0xA8,	
		   WRITE_FUSE_EXTENDED_msb=0xAC,  
		   WRITE_FUSE_EXTENDED_lsb=0xA4,  
		   READ_FUSE_LOW_msb=0x50,     
		   READ_FUSE_LOW_lsb=0x00,	   
		   READ_FUSE_HIGH_msb=0x58,	
		   READ_FUSE_HIGH_lsb=0x08,	
		   READ_FUSE_EXTENDED_msb=0x50, 
		   READ_FUSE_EXTENDED_lsb=0x08; 	   
		   
		   			  

BYTE SendRecieve(unsigned int dat){
unsigned char temp;
PDO(dat>>7);SCK(1);delay(1);temp  =PDI();temp<<=1;SCK(0);delay(1);							  
PDO(dat>>6);SCK(1);delay(1);temp |=PDI();temp<<=1;SCK(0);delay(1);
PDO(dat>>5);SCK(1);delay(1);temp |=PDI();temp<<=1;SCK(0);delay(1);
PDO(dat>>4);SCK(1);delay(1);temp |=PDI();temp<<=1;SCK(0);delay(1);
PDO(dat>>3);SCK(1);delay(1);temp |=PDI();temp<<=1;SCK(0);delay(1);
PDO(dat>>2);SCK(1);delay(1);temp |=PDI();temp<<=1;SCK(0);delay(1);
PDO(dat>>1);SCK(1);delay(1);temp |=PDI();temp<<=1;SCK(0);delay(1);
PDO(dat   );SCK(1);delay(1);temp |=PDI();        ;SCK(0);delay(1);

//PDO(dat>>7);SCK(1);delay(1);SCK(0);delay(1);temp  =PDI();temp<<=1;							  
//PDO(dat>>6);SCK(1);delay(1);SCK(0);delay(1);temp |=PDI();temp<<=1;
//PDO(dat>>5);SCK(1);delay(1);SCK(0);delay(1);temp |=PDI();temp<<=1;
//PDO(dat>>4);SCK(1);delay(1);SCK(0);delay(1);temp |=PDI();temp<<=1;
//PDO(dat>>3);SCK(1);delay(1);SCK(0);delay(1);temp |=PDI();temp<<=1;
//PDO(dat>>2);SCK(1);delay(1);SCK(0);delay(1);temp |=PDI();temp<<=1;
//PDO(dat>>1);SCK(1);delay(1);SCK(0);delay(1);temp |=PDI();temp<<=1;
//PDO(dat   );SCK(1);delay(1);SCK(0);delay(1);temp |=PDI();        ;


return (temp);}

void mega128_read(unsigned int adr,BYTE cnt, BYTE *p){
		  while(cnt>0){
		  SendRecieve(READ_MEM);
		  SendRecieve(adr>>8);
		  SendRecieve(adr);
		  *p=SendRecieve(0);p++;		  
		  SendRecieve(READ_MEM|8);
		  SendRecieve(adr>>8);
		  SendRecieve(adr);		  
		  *p=SendRecieve(0);p++;
		  cnt--;adr++;
		  }

 }      

void mega128_LoadBuff(BYTE adr,BYTE cnt,BYTE*p){
	   while(cnt>0){
		  SendRecieve(LOAD_PGM_PAGE);
		  SendRecieve(0);
		  SendRecieve(adr);
		  SendRecieve(*p);p++;		  		  
		  SendRecieve(LOAD_PGM_PAGE|8);
		  SendRecieve(0);
		  SendRecieve(adr);
		  SendRecieve(*p);p++;
		  cnt--;adr++;	  
			  }
}

//		 load_page(){
//		 for(a=0;a<32;a++) page[a+32*(7&usb_in[1])]=usb_in[a+2];
//			 if ((7&usb_in[1])==7){	 
//			       for(a=0;a<128;a++){        
//		 	 CMD[0]=LOAD_PGM_PAGE;CMD[1]=0;CMD[2]=a;CMD[3]=page[a*2];SEND();//
//			 CMD[0]|=8;CMD[1]=0;CMD[2]=a;CMD[3]=page[a*2+1];SEND();//	
//						 }}
//			 }
void mega128_PgmPage(unsigned int page){
                  
		  SendRecieve(WRITE_PGM_PAGE);
		  SendRecieve(page>>1);
		  SendRecieve(page<<7);
		  SendRecieve(0);				  		
}
//
//		pgm_page(){
//		   CMD[0]=WRITE_PGM_PAGE;CMD[1]=usb_in[1];CMD[2]=usb_in[2];CMD[3]=0;SEND();//
//		
//		   }
//		

    pgm_ena(unsigned char *p){
	       SCK(0);
		   FIO0SET=1<<2;delay(1);
		   FIO0CLR=1<<2;delay(1);

 	   
		   *p=SendRecieve(PRG_ENA);p++;
		   *p=SendRecieve(0x53);p++;
		   *p=SendRecieve(0);p++;
		   *p=SendRecieve(0);p++;

         }
		  

  void mega128_erase(void){
  	 SendRecieve(CHIP_ERASE);
	 SendRecieve(0x80);
     SendRecieve(0);
	 SendRecieve(0);
	 SendRecieve(0);
     
  }		
//
//  chip_erase(){
//		      CMD[0]=CHIP_ERASE;CMD[1]=0x80;CMD[2]=0;CMD[3]=0;SEND();
//		     
//		     }

//
//Write Fuse bits          1010 1100    1010 0000    xxxx xxxx iiii iiii
//Write Fuse High Bits     1010 1100    1010 1000    xxxx xxxx iiii iiii
//Write Extended Fuse bits 1010 1100    1010 0100    xxxx xxxx xxxx xxii
///////////tWD_FUSE 4.5 ms

void mega128_WriteFuseExtended(unsigned char fuse){
	 pgm_ena(&usb_out[3]);
  SendRecieve(WRITE_FUSE_EXTENDED_msb);
  SendRecieve(WRITE_FUSE_EXTENDED_lsb);
  SendRecieve(0);
  SendRecieve(fuse); 
}
void mega128_WriteFuseHigh(unsigned char fuse){
	 pgm_ena(&usb_out[3]);  
  SendRecieve(WRITE_FUSE_HIGH_msb);
  SendRecieve(WRITE_FUSE_HIGH_lsb);
  SendRecieve(0);
  SendRecieve(fuse);
  }
void mega128_WriteFuseLow(unsigned char fuse){
	 pgm_ena(&usb_out[3]);
  SendRecieve(WRITE_FUSE_LOW_msb);
  SendRecieve(WRITE_FUSE_LOW_lsb);
  SendRecieve(0);
  SendRecieve(fuse);
							
}

//Read Fuse bits           0101 0000 0000 0000 xxxx xxxx oooo oooo
//Read Extendend Fuse bits 0101 0000 0000 1000 xxxx xxxx oooo oooo
//Read Fuse High Bits      0101 1000 0000 1000 xxxx xxxx oooo oooo


void mega128_GetFuses(unsigned char *p){
	 
	 pgm_ena(&usb_out[3]);
	 SCK(0);
	 delay(5);
	 SendRecieve(READ_FUSE_EXTENDED_msb);
	 SendRecieve(READ_FUSE_EXTENDED_lsb);
     SendRecieve(0x00);
	 *p=SendRecieve(0);
	  p++;
	
	 pgm_ena(&usb_out[3]);
	 SCK(0);
	 delay(5);
  	 SendRecieve(READ_FUSE_HIGH_msb);
	 SendRecieve(READ_FUSE_HIGH_lsb);
     SendRecieve(0x00);
	 *p=SendRecieve(0);
	  p++;
	 
	  pgm_ena(&usb_out[3]);
  	 SendRecieve(READ_FUSE_LOW_msb);
	 SendRecieve(READ_FUSE_LOW_lsb);
     SendRecieve(0x00);
	 *p=SendRecieve(0); 
	 	  
	  }	
//Read Signature Byte 0011 0000 xxxx   xxxx xxxx   xxbb oooo oooo Read Signature Byte o at address b.
void mega128_GetID(unsigned char *p){
	 pgm_ena(&usb_out[3]);
	 SCK(0);

  	 SendRecieve(0x30);
	 SendRecieve(0x00);
     SendRecieve(0x00);
	 *p=SendRecieve(0);
	  p++;
	 
	 
  	 SendRecieve(0x30);
	 SendRecieve(0x00);
     SendRecieve(0x01);
	 *p=SendRecieve(0);
	  p++;

  	 SendRecieve(0x30);
	 SendRecieve(0x00);
     SendRecieve(0x02);
	 *p=SendRecieve(0);
	  p++;

  	 SendRecieve(0x30);
	 SendRecieve(0x00);
     SendRecieve(0x03);
	 *p=SendRecieve(0);
	  

}

