extern unsigned int const SCL_PIN,SDA_PIN,RESET_PIN;
extern void delay(unsigned int);
extern void scl(unsigned int);
extern void sda(unsigned int);
extern unsigned int sdain(void);
extern unsigned int sclin(void);
extern void p_pulse(unsigned int,unsigned int);

BYTE send( unsigned int data){
data|=0x100;
data&=0x1FF;
while(data<0x10000){
    sda(data>>7);	
	scl(0);delay(5);
    scl(1);delay(5);
	data<<=1;}
    scl(0);sda(1);
    delay(5);scl(1);
    delay(5);
    data=sdain(); scl(0);
   
 return(data);
 }

BYTE recieve(){
unsigned int data;
data=1;
sda(1);delay(5);
while(data<0x100){
    scl(0);delay(5);scl(1);delay(5);
    data<<=1;data|=sdain();
    delay(5);}
	scl(0);sda(1);//Orion's ACK=1 !!!!	
	delay(5);scl(1);
	delay(5);scl(0);
	
return(data);
}


unsigned int orion100_read(unsigned int adr,unsigned int cnt,BYTE *p) {      
unsigned int err;
			sda(1);scl(1);
			 p_pulse(1,10);
            sda(0);delay(5);scl(0);
			if(send(0xAA)!=0) return(100);
			delay(10);
		   	if (send(adr>>8)!=0) return(101);  //
			delay(10);
			if (send(adr)!=0) return(102);
			while(err==0 && cnt>0){
			delay(100);
			*p=recieve();p++;cnt--;
			delay(10);
				   }
             return (0);
		     	  }
	

//------------------------------------------
unsigned int orion100_write(unsigned int adr,unsigned int cnt, BYTE *p){
unsigned int err;       
	         
			 err=0;
     		 while(err==0 && cnt>0){
			  sda(1);scl(1);
			 p_pulse(1,10);
			 //while((sclin()&sdain())==0);
 			 sda(0);delay(5);scl(0);
			 if(send(0x95)!=0)          return(141);
			 delay(5);			 
             if(send(0x80|(adr>>8))!=0) return(142); // !!! OR 0x80 NEEDED in firmware
			 delay(5);
			 if (send(adr)!=0)          return(143);
			 delay(5);  
			 if (send(*p)!=0)           return(144);
			 delay(500);p++;cnt--;adr++;
				}
			return(0);
}





